import math,stats
from score import score,score_cont

class BDE(score):
    def __init__(self,n_disc):
        score.__init__(self,n_disc)
        self.alpha = 1.0
        self.H = 1.0
        
    def HP(self,n_disc):
        return self.H*max(2,n_disc)
    
    def graph_score_alg1(self,n_vert,n_disc,par_disc,n_data):
        return self.graph_score(n_vert,len(par_disc),n_data)
        #graph_struct=(1+len(par_disc))*math.log(n_vert,2)
        #graph_cpd=0.5*(n_disc-1)*math.log(n_data,2)
        #for p_disc in par_disc:
        #    graph_cpd*=p_disc
        #return graph_struct+graph_cpd
        
    def graph_score(self,n_vert,n_par,n_data):
        #s = math.log(1.0 / math.pow(2.0,((1+n_par)*math.log(n_vert,2))))   #
        #s2 = (1+n_par)*math.log(n_vert)#*math.log(self.alpha,2)
        #print -s,s2,s/s2
        return n_par*self.alpha
    
    def data_min(self,v,data):
        HP=self.HP(v.n_disc)
        sd = self.sel_data(v,[],data)
        stats_all,stats_par = self.stats(sd,v,[])
        #print sd,stats_all,stats_par
        #par_counted = []
        if v.n_disc:
            s = 0 #math.log(self.H)
            for a,cv in stats_all.items():
                #aaa =s
                for i in range(0,cv):
                    #print"xxx",  self.H+i,math.log(self.H+i) #,2),s
                    s-=math.log(self.H+i) #,2),s
                    s+=math.log(HP+i) #,2)
                #print s-aaa
        else:
            gh = stats.gammln(self.H)
            s = stats.gammln(HP+stats_par[()])-stats.gammln(HP)
            for a,cv in stats_all.items():
                s+=gh-stats.gammln(self.H+cv)
        #print -s
        return s
    
    def data_score(self,v,par,data):
        HP=self.HP(v.n_disc)
        sd = self.sel_data(v,par,data)
        stats_all,stats_par = self.stats(sd,v,par)
        #print sd,stats_all,stats_par
        s = 0 #math.log(self.H)
        if 0 not in map(lambda p: p.n_disc,par+[v]):
            par_counted = []
            for a,cv in stats_all.items():
                par = a[:-1]
                cp = stats_par[par]
                if par not in par_counted:
                    tmp =0
                    for i in range(0,cp):
                        #print "+++", self.H+i,math.log(self.H+i) #,2)
                        tmp+=math.log(HP+i) #,2)
                    s+=tmp
                    #print "---",tmp,s
                    par_counted.append(par)
                    
                #aaa =s
                for i in range(0,cv):
                    #print"xxx",  self.H+i,math.log(self.H+i) #,2),s
                    s-=math.log(self.H+i) #,2),s
                #print s-aaa
        else:
            gh = stats.gammln(self.H)
            ghp = stats.gammln(HP)
            for a,cv in stats_all.items():
                s+=gh-stats.gammln(self.H+cv)
            for a,cp in stats_par.items():
                s+=stats.gammln(HP+cp)-ghp
        #print -s
        return s*self.data_factor

	
class BDE_cont(score_cont,BDE):

    def graph_score(self,n_vert,n_par,n_data):
        return n_par*self.alpha*0.1
    
    def data_min(self,v,data):
        HP=self.HP(v.n_disc)
        sd = self.sel_data(v,[],data)
        stats_all,stats_par = self.stats(sd)
        gh = stats.gammln(self.H)
        s = stats.gammln(HP+stats_par[()])-stats.gammln(HP)
        for a,cv in stats_all.items():
            s+=gh-stats.gammln(self.H+cv)
        return s

    def data_score(self,v,par,data):
        HP=self.HP(v.n_disc)
        sd = self.sel_data(v,par,data)
        stats_all,stats_par = self.stats(sd)
        s = 0 #math.log(self.H)
        gh = stats.gammln(self.H)
        ghp = stats.gammln(HP)
        for a,cv in stats_all.items():
            s+=gh-stats.gammln(self.H+cv)
        for a,cp in stats_par.items():
            s+=stats.gammln(HP+cp)-ghp
        return s
