import math
from score import score,score_cont

class MDL(score):
    cont_factor=2
    
    def graph_score(self,n_vert,n_par,n_data):
        return self.md_graph(n_vert,n_par,n_data)
    
    def graph_score_alg1(self,n_vert,n_disc,par_disc,n_data):
        graph_struct=(1+len(par_disc))*math.log(n_vert,2)
        graph_cpd=0.5*(max(self.cont_factor,n_disc)-1)*math.log(n_data,2)
        for p_disc in par_disc:
            graph_cpd*=max(self.cont_factor,p_disc)
        return graph_struct+graph_cpd
    
    def data_score(self,v,par,data):
        return self.md_data(v,par,data)*self.data_factor
    
    def md_graph(self,n_vert,n_par,n_data):
        return self.md_graph_struct(n_vert,n_par,n_data) + \
               self.md_graph_cpd(n_vert,n_par,n_data)

    def md_graph_struct(self,n_vert,n_par,n_data):
        return (1+n_par)*math.log(n_vert,2)

    def md_graph_cpd(self,n_vert,n_par,n_data):
        n_disc=max(self.cont_factor,self.n_disc)
        return  0.5*math.pow(n_disc,n_par)*(n_disc-1)*math.log(n_data,2)

    def md_data(self,v,par,data):
        sd = self.sel_data(v,par,data)
        stats_all,stats_par = self.stats(sd,v,par)
        #print sd,stats_all,stats_par
        s = 0.0
        for a,cv in stats_all.items():
            par = a[:-1]
            cp = stats_par[par]
            try:
                sc = math.log(1.0*cp/cv,2)
                #print par,a,cp,cv,sc
                s+=cv*sc
            except ZeroDivisionError:
                pass
        return s


class MDL_cont(score_cont,MDL):

    def md_graph_cpd(self,n_vert,n_par,n_data):
        return  0.5*2**n_par*math.log(n_data,2)
    
    def graph_score(self,n_vert,n_par,n_data):
        return self.md_graph(n_vert,n_par,n_data)#*0.3
