import hmm_regul, data, graph
sts=["0","1","2","3","4","5"]

obs_art_4=data.dataset().fromNewFile(open("../data/4_osc_new.inp"))
obs_art12=data.dataset().fromNewFile(open("../data/12_osc_new.inp"))
obs_thief=data.dataset().fromNewFile(open("../data/thieffry.inp"))
obs_novak=data.dataset().fromNewFile(open("../data/novak.inp"))
obs_real=data.dataset().fromNewFile(open("../data/hela.inp"))

obss = [obs_art_4,obs_art12,obs_thief,obs_novak,obs_real]

for o in obss:
    l = map(lambda x: len(x.data), o.points)
    print sum(l),l

g_art_4 = graph.graph().from_SIF(open("../data/osc_4.sif"))
g_art12 = graph.graph().from_SIF(open("../data/osc_12.sif"))
g_novak = graph.graph().from_SIF(open("../data/novak.sif"))
g_thief = graph.graph().from_SIF(open("../data/thieffry.sif"))

genes_thief = map (str, obs_thief.vertices)
genes_novak = map (str, obs_novak.vertices)
genes_real = map (str, obs_real.vertices)

genes_thief.sort()
genes_novak.sort()
genes_real.sort()

print  genes_thief
print  genes_novak
print  genes_real

g_all=[]
g_n_t=[]
g_t_r=[]
for g in genes_thief:
    if g in genes_novak and g in genes_real:
        g_all.append(g)
    if g in genes_novak:
        g_n_t.append(g)
    if  g in genes_real:
        g_t_r.append(g)
    
print g_all
print g_n_t
print g_t_r


_,net_bde_art_4 = obs_art_4.learn(score="BDE",data_factor=10.0)
_,net_bde_art12 = obs_art12.learn(score="BDE",data_factor=10.0)
_,net_bde_thief = obs_thief.learn(score="BDE",data_factor=10.0)
_,net_bde_novak = obs_novak.learn(score="BDE",data_factor=10.0)
_,net_bde_real  = obs_real.learn(score="BDE",data_factor=10.0)

_,net_mdl_art_4 = obs_art_4.learn(score="MDL",data_factor=10.0)
_,net_mdl_art12 = obs_art12.learn(score="MDL",data_factor=10.0)
_,net_mdl_thief = obs_thief.learn(score="MDL",data_factor=10.0)
_,net_mdl_novak = obs_novak.learn(score="MDL",data_factor=10.0)
_,net_mdl_real  = obs_real.learn(score="MDL",data_factor=10.0)


sln_art_4 = hmm_regul.SLN_fast(obs_art_4.n_gen,sts[:obs_art_4.n_disc])
sln_art12 = hmm_regul.SLN_fast(obs_art12.n_gen,sts[:obs_art12.n_disc])
sln_thief = hmm_regul.SLN_fast(obs_thief.n_gen,sts[:obs_thief.n_disc])
sln_novak = hmm_regul.SLN_fast(obs_novak.n_gen,sts[:obs_novak.n_disc])
sln_real  = hmm_regul.SLN_fast(obs_real.n_gen,sts [:obs_real.n_disc])

obs_real.split_by_diff()
#obs_novak.split_by_diff()
#obs_thief.split_by_diff()

net_sln_art_4 = sln_art_4.learn_dataset(obs_art_4)
net_sln_art12 = sln_art12.learn_dataset(obs_art12)
net_sln_thief = sln_thief.learn_dataset(obs_thief)
net_sln_novak = sln_novak.learn_dataset(obs_novak)
net_sln_real  = sln_real.learn_dataset(obs_real)

print "XXXXXXXXXXXXXXXXXXX ARTIFICIAL 4 XXXXXXXXXXXXXXXXXX"
print net_sln_art_4.compare(g_art_4)
print net_bde_art_4.compare(g_art_4)
print net_mdl_art_4.compare(g_art_4)

print "XXXXXXXXXXXXXXXXXXX ARTIFICIAL 12 XXXXXXXXXXXXXXXXXX"
print net_sln_art12.compare(g_art12)
print net_bde_art12.compare(g_art12)
print net_mdl_art12.compare(g_art12)

print "XXXXXXXXXXXXXXXXXXX THIEFFRY XXXXXXXXXXXXXXXXXX"
print net_sln_thief.compare(g_thief)
print net_bde_thief.compare(g_thief)
print net_mdl_thief.compare(g_thief)

print "XXXXXXXXXXXXXXXXXXX NOVAK XXXXXXXXXXXXXXXXXX"

print net_sln_novak.compare(g_novak)
print net_bde_novak.compare(g_novak)
print net_mdl_novak.compare(g_novak)

print "XXXXXXXXXXXXXXXXXXX REAL XXXXXXXXXXXXXXXXXX"


print net_sln_real.compare(g_thief)
print net_bde_real.compare(g_thief)
print net_mdl_real.compare(g_thief)

geom = graph.read_gml_geometry(open("../data/thieffry.gml"))
geom4 = graph.read_gml_geometry(open("../data/osc_4.gml"))
geom12= graph.read_gml_geometry(open("../data/osc_12.gml"))

net_ref_thief = g_thief.labels_2_verts()
net_ref_novak = g_novak.labels_2_verts()
net_ref_art_4 = g_art_4.labels_2_verts()
net_ref_art12 = g_art12.labels_2_verts()


nets = [net_sln_art_4,net_sln_art12,net_sln_thief,net_sln_novak,net_sln_real,
        net_mdl_art_4,net_mdl_art12,net_mdl_thief,net_mdl_novak,net_mdl_real,
        net_bde_art_4,net_bde_art12,net_bde_thief,net_bde_novak,net_bde_real
        ]
file_names = ["net_sln_art_4","net_sln_art12","net_sln_thief","net_sln_novak","net_sln_real",
              "net_mdl_art_4","net_mdl_art12","net_mdl_thief","net_mdl_novak","net_mdl_real",
              "net_bde_art_4","net_bde_art12","net_bde_thief","net_bde_novak","net_bde_real"
              ]
refs = [net_ref_art_4,net_ref_art12,net_ref_thief,net_ref_novak,net_ref_thief]*3
geoms = [geom4, geom12, geom,geom,geom]*3

print net_ref_art_4
print net_ref_art12
print net_ref_thief
print net_ref_novak

for f,n,r,g in zip(file_names,nets,refs,geoms):
    f_sif=open("../output/%s.sif"%f,"w")
    f_gml=open("../output/%s.gml"%f,"w")
    f_sif.write(n.to_SIF())
    n1 = n.labels_2_verts()
    l = filter(lambda x: x in n1.vertices, r.vertices)
    n1 = n1.subgraph(l,forward=False)
    for i in n1.vertices:
        n1.vertice_labelling[i]=i
    n1.to_GML(f_gml,g,r)
    f_gml.close()
    f_sif.close()
    print f
    print n1

